<?php
// $Id: phpbb_api_hooks.php,v 1.2 2009/03/05 19:41:33 vb Exp $
/**
 * Copyright (C) 2008-2009 by Vadim G.B. (http://vgb.org.ru)
 */

if (!defined('IN_PHPBB'))
  die('Hacking attempt...');

// Hooks

function phpbb_hook_init()
{
  global $phpbb_hook, $cache, $phpbb_root_path, $phpEx, $phpbb_hook;
  if (empty($phpbb_hook))
  {
    $phpbb_hook = new phpbb_hook(array('exit_handler', 'phpbb_user_session_handler', 'append_sid', array('template', 'display')));

    foreach ($cache->obtain_hooks() as $hook)
    {
    	@include_once($phpbb_root_path . 'includes/hooks/' . $hook . '.' . $phpEx);
    }
  }
}

function phpbb_hook_register(&$hook)
{
	$hook->register('append_sid', 'phpbb_hook_append_sid');
  $hook->register('exit_handler', 'phpbb_hook_exit_handler');
}

/**
* Append session id to url
*/
function phpbb_hook_append_sid(&$hook, $url, $params = false, $is_amp = true, $session_id = false)
{
	global $_SID, $_EXTRA_URL;
	global $phpbb_config, $phpbb_root_path, $phpEx, $phpbb_hook,
	  $site_base_url, $site_phpbb_page, $site_forum_url, $phpbb_integration_mode;

  // Get possible previous results
	$result = $hook->previous_hook_result('append_sid');

 	//if ($phpbb_integration_mode == 1)
  //	$phpbb_url = $site_forum_url;
  //else
  $phpbb_url = $phpbb_config['forum_url'];
	$phpbb_url .= '/';

  //$phpbb_url_len = strlen($phpbb_url);

  $phpbb_root_path_len = strlen($phpbb_root_path);
  if ($url[0] != '.' && substr($url, 0, $phpbb_root_path_len) == $phpbb_root_path && strpos($url, $phpbb_url) === false)
	{
		$url = $phpbb_url . substr($url, $phpbb_root_path_len);
	}
	// Assign sid if session id is not specified
	if ($session_id === false)
	{
		$session_id = $_SID;
	}

	$amp_delim = ($is_amp) ? '&amp;' : '&';
	$url_delim = (strpos($url, '?') === false) ? '?' : $amp_delim;

	// Appending custom url parameter?
	$append_url = (!empty($_EXTRA_URL)) ? implode($amp_delim, $_EXTRA_URL) : '';

	$anchor = '';
	if (strpos($url, '#') !== false)
	{
		list($url, $anchor) = explode('#', $url, 2);
		$anchor = '#' . $anchor;
	}
	else if (!is_array($params) && strpos($params, '#') !== false)
	{
		list($params, $anchor) = explode('#', $params, 2);
		$anchor = '#' . $anchor;
	}

	// Use the short variant if possible ;)
	if ($params === false)
	{
		// Append session id
		if (!$session_id)
		{
			return $url . (($append_url) ? $url_delim . $append_url : '') . $anchor;
		}
		else
		{
			return $url . (($append_url) ? $url_delim . $append_url . $amp_delim : $url_delim) . 'sid=' . $session_id . $anchor;
		}
	}

	// Build string if parameters are specified as array
	if (is_array($params))
	{
		$output = array();

		foreach ($params as $key => $item)
		{
			if ($item === NULL)
			{
				continue;
			}

			if ($key == '#')
			{
				$anchor = '#' . $item;
				continue;
			}

			$output[] = $key . '=' . $item;
		}

		$params = implode($amp_delim, $output);
	}

	// Append session id and parameters (even if they are empty)
	// If parameters are empty, the developer can still append his/her parameters without caring about the delimiter
	return $url . (($append_url) ? $url_delim . $append_url . $amp_delim : $url_delim) . $params . ((!$session_id) ? '' : $amp_delim . 'sid=' . $session_id) . $anchor;
}

/**
* Handler for exit calls in phpBB.
*/
function phpbb_hook_exit_handler(&$hook)
{
  global $config;
  // Get possible previous results
	$result = $hook->previous_hook_result('exit_handler');
  //drupal_set_message("***phpbb_hook_exit_handler");

  // As a pre-caution... some setups display a blank page if the flush() is not there.
	//(empty($config['gzip_compress'])) ? @flush() : @ob_flush();
  
  global $_phpbb_result;

  $_phpbb_result['output'] = ob_get_clean();
  $_phpbb_result['status'] = 'exit';
  //$url = $_phpbb_result['url'];
  $destination = _phpbbforum_get_destination();
  $url = $destination['url'];
  $_phpbb_result['url'] = '';
  _phpbbforum_set_result($_phpbb_result);
  _phpbbforum_goto($url);

  return true;

}

////////////////////////////////////////////////////////////////////////

function phpbbforum_redirect($url)
{
  global $_phpbb_result;
  //if (1/*!$_phpbb_result['redirect'] || $_phpbb_result['redirect'] != _phpbbforum_replace_urls($url)*/)
  if (!$_phpbb_result['redirect'] /*|| $_phpbb_result['redirect'] != _phpbbforum_replace_urls($url)*/)
  {
    $url = _phpbbforum_replace_urls($url);
    //$_phpbb_result['redirect'] = $url;

    //_phpbbforum_set_message($url);
  }

  //_phpbbforum_set_message('Redirect phpBB='. $url);

  $_phpbb_result['redirect'] = '';
  $_phpbb_result['destination'] = $url;

  //$_phpbb_result['output'] = '';

  $_phpbb_result['status'] = 'redirect';
  _phpbbforum_set_result($_phpbb_result);
  _phpbbforum_set_destination($url);
  _phpbbforum_goto($url);

  exit;
}

//function msg_handler($errno, $msg_text, $errfile, $errline)
function phpbb_error_msg_handler($errno, $msg_text, $errfile, $errline)
{
  global $_phpbb_result;

	// Do not display notices if we suppress them via @
	if (error_reporting() == 0)
	{
		return;
	}

  $_phpbb_result['errno'] = $errno;
  $_phpbb_result['error_msg'] = $msg_text;
  
	// If we notice an error not handled here we pass this back to PHP by returning false
	// This may not work for all php versions
	return false;
}

?>